--[[
    Fail game engine
    Copyright 2007-2008 Antoine Chavasse <a.chavasse@gmail.com>
 
    This file is part of Fail.

    Fail is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License version 3
    as published by the Free Software Foundation.

    Fail is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
--]]

module( "fail.game.keyboard", package.seeall )

require 'fail.game.input'
require 'qtgui'

Provider = fail.utils.class
{
	superclass = fail.game.input.EventProvider,
	
	function( self, widget )
		fail.game.input.EventProvider.init( self, "keyboard" )

		widget.keyPressEvent = function( o, ke ) self:keyEvent( ke, true ) end
		widget.keyReleaseEvent = function( o, ke ) self:keyEvent( ke, false ) end
	end,
}

function Provider:keyEvent( ke, pressed )
	if( ke:isAutoRepeat() ) then
		return
	end

	local name = KeyToSymbol[ ke:key() ]
	local eventsource = fail.game.input.EventSource( self, name )
	local event = fail.game.input.KeyEvent( eventsource, pressed )
	fail.game.input.InputManager.GetInstance():feedKeyEvent( event )
end

KeyToSymbol =
{
	[0x01000000] = 'Escape',
	[0x01000001] = 'Tab',
	[0x01000002] = 'Backtab',
	[0x01000003] = 'Backspace',
	[0x01000004] = 'Return',
	[0x01000005] = 'Enter',
	[0x01000006] = 'Insert',
	[0x01000007] = 'Delete',
	[0x01000008] = 'Pause',
	[0x01000009] = 'Print',
	[0x0100000a] = 'SysReq',
	[0x0100000b] = 'Clear',
	[0x01000010] = 'Home',
	[0x01000011] = 'End',
	[0x01000012] = 'Left',
	[0x01000013] = 'Up',
	[0x01000014] = 'Right',
	[0x01000015] = 'Down',
	[0x01000016] = 'PageUp',
	[0x01000017] = 'PageDown',
	[0x01000020] = 'Shift',
	[0x01000021] = 'Control',
	[0x01000022] = 'Meta',
	[0x01000023] = 'Alt',
	[0x01000024] = 'CapsLock',
	[0x01000025] = 'NumLock',
	[0x01000026] = 'ScrollLock',
	[0x01000030] = 'F1',
	[0x01000031] = 'F2',
	[0x01000032] = 'F3',
	[0x01000033] = 'F4',
	[0x01000034] = 'F5',
	[0x01000035] = 'F6',
	[0x01000036] = 'F7',
	[0x01000037] = 'F8',
	[0x01000038] = 'F9',
	[0x01000039] = 'F10',
	[0x0100003a] = 'F11',
	[0x0100003b] = 'F12',
	[0x0100003c] = 'F13',
	[0x0100003d] = 'F14',
	[0x0100003e] = 'F15',
	[0x0100003f] = 'F16',
	[0x01000040] = 'F17',
	[0x01000041] = 'F18',
	[0x01000042] = 'F19',
	[0x01000043] = 'F20',
	[0x01000044] = 'F21',
	[0x01000045] = 'F22',
	[0x01000046] = 'F23',
	[0x01000047] = 'F24',
	[0x01000048] = 'F25',
	[0x01000049] = 'F26',
	[0x0100004a] = 'F27',
	[0x0100004b] = 'F28',
	[0x0100004c] = 'F29',
	[0x0100004d] = 'F30',
	[0x0100004e] = 'F31',
	[0x0100004f] = 'F32',
	[0x01000050] = 'F33',
	[0x01000051] = 'F34',
	[0x01000052] = 'F35',
	[0x01000053] = 'Super_L',
	[0x01000054] = 'Super_R',
	[0x01000055] = 'Menu',
	[0x01000056] = 'Hyper_L',
	[0x01000057] = 'Hyper_R',
	[0x01000058] = 'Help',
	[0x01000059] = 'Direction_L',
	[0x01000060] = 'Direction_R',
	[0x20] = 'Space',
	[0x21] = 'Exclam',
	[0x22] = 'QuoteDbl',
	[0x23] = 'NumberSign',
	[0x24] = 'Dollar',
	[0x25] = 'Percent',
	[0x26] = 'Ampersand',
	[0x27] = 'Apostrophe',
	[0x28] = 'ParenLeft',
	[0x29] = 'ParenRight',
	[0x2a] = 'Asterisk',
	[0x2b] = 'Plus',
	[0x2c] = 'Comma',
	[0x2d] = 'Minus',
	[0x2e] = 'Period',
	[0x2f] = 'Slash',
	[0x30] = '0',
	[0x31] = '1',
	[0x32] = '2',
	[0x33] = '3',
	[0x34] = '4',
	[0x35] = '5',
	[0x36] = '6',
	[0x37] = '7',
	[0x38] = '8',
	[0x39] = '9',
	[0x3a] = 'Colon',
	[0x3b] = 'Semicolon',
	[0x3c] = 'Less',
	[0x3d] = 'Equal',
	[0x3e] = 'Greater',
	[0x3f] = 'Question',
	[0x40] = 'At',
	[0x41] = 'A',
	[0x42] = 'B',
	[0x43] = 'C',
	[0x44] = 'D',
	[0x45] = 'E',
	[0x46] = 'F',
	[0x47] = 'G',
	[0x48] = 'H',
	[0x49] = 'I',
	[0x4a] = 'J',
	[0x4b] = 'K',
	[0x4c] = 'L',
	[0x4d] = 'M',
	[0x4e] = 'N',
	[0x4f] = 'O',
	[0x50] = 'P',
	[0x51] = 'Q',
	[0x52] = 'R',
	[0x53] = 'S',
	[0x54] = 'T',
	[0x55] = 'U',
	[0x56] = 'V',
	[0x57] = 'W',
	[0x58] = 'X',
	[0x59] = 'Y',
	[0x5a] = 'Z',
	[0x5b] = 'BracketLeft',
	[0x5c] = 'Backslash',
	[0x5d] = 'BracketRight',
	[0x5e] = 'AsciiCircum',
	[0x5f] = 'Underscore',
	[0x60] = 'QuoteLeft',
	[0x7b] = 'BraceLeft',
	[0x7c] = 'Bar',
	[0x7d] = 'BraceRight',
	[0x7e] = 'AsciiTilde',
	[0x0a0] = 'nobreakspace',
	[0x0a1] = 'exclamdown',
	[0x0a2] = 'cent',
	[0x0a3] = 'sterling',
	[0x0a4] = 'currency',
	[0x0a5] = 'yen',
	[0x0a6] = 'brokenbar',
	[0x0a7] = 'section',
	[0x0a8] = 'diaeresis',
	[0x0a9] = 'copyright',
	[0x0aa] = 'ordfeminine',
	[0x0ab] = 'guillemotleft',
	[0x0ac] = 'notsign',
	[0x0ad] = 'hyphen',
	[0x0ae] = 'registered',
	[0x0af] = 'macron',
	[0x0b0] = 'degree',
	[0x0b1] = 'plusminus',
	[0x0b2] = 'twosuperior',
	[0x0b3] = 'threesuperior',
	[0x0b4] = 'acute',
	[0x0b5] = 'mu',
	[0x0b6] = 'paragraph',
	[0x0b7] = 'periodcentered',
	[0x0b8] = 'cedilla',
	[0x0b9] = 'onesuperior',
	[0x0ba] = 'masculine',
	[0x0bb] = 'guillemotright',
	[0x0bc] = 'onequarter',
	[0x0bd] = 'onehalf',
	[0x0be] = 'threequarters',
	[0x0bf] = 'questiondown',
	[0x0c0] = 'Agrave',
	[0x0c1] = 'Aacute',
	[0x0c2] = 'Acircumflex',
	[0x0c3] = 'Atilde',
	[0x0c4] = 'Adiaeresis',
	[0x0c5] = 'Aring',
	[0x0c6] = 'AE',
	[0x0c7] = 'Ccedilla',
	[0x0c8] = 'Egrave',
	[0x0c9] = 'Eacute',
	[0x0ca] = 'Ecircumflex',
	[0x0cb] = 'Ediaeresis',
	[0x0cc] = 'Igrave',
	[0x0cd] = 'Iacute',
	[0x0ce] = 'Icircumflex',
	[0x0cf] = 'Idiaeresis',
	[0x0d0] = 'ETH',
	[0x0d1] = 'Ntilde',
	[0x0d2] = 'Ograve',
	[0x0d3] = 'Oacute',
	[0x0d4] = 'Ocircumflex',
	[0x0d5] = 'Otilde',
	[0x0d6] = 'Odiaeresis',
	[0x0d7] = 'multiply',
	[0x0d8] = 'Ooblique',
	[0x0d9] = 'Ugrave',
	[0x0da] = 'Uacute',
	[0x0db] = 'Ucircumflex',
	[0x0dc] = 'Udiaeresis',
	[0x0dd] = 'Yacute',
	[0x0de] = 'THORN',
	[0x0df] = 'ssharp',
	[0x0f7] = 'division',
	[0x0ff] = 'ydiaeresis',
	[0x01001103] = 'AltGr',
	[0x01001120] = 'Multi_key',
	[0x01001137] = 'Codeinput',
	[0x0100113c] = 'SingleCandidate',
	[0x0100113d] = 'MultipleCandidate',
	[0x0100113e] = 'PreviousCandidate',
	[0x0100117e] = 'Mode_switch',
	[0x0100117e] = 'script_switch',
	[0x01001121] = 'Kanji',
	[0x01001122] = 'Muhenkan',
	[0x01001123] = 'Henkan_Mode',
	[0x01001123] = 'Henkan',
	[0x01001124] = 'Romaji',
	[0x01001125] = 'Hiragana',
	[0x01001126] = 'Katakana',
	[0x01001127] = 'Hiragana_Katakana',
	[0x01001128] = 'Zenkaku',
	[0x01001129] = 'Hankaku',
	[0x0100112a] = 'Zenkaku_Hankaku',
	[0x0100112b] = 'Touroku',
	[0x0100112c] = 'Massyo',
	[0x0100112d] = 'Kana_Lock',
	[0x0100112e] = 'Kana_Shift',
	[0x0100112f] = 'Eisu_Shift',
	[0x01001130] = 'Eisu_toggle',
	[0x01001137] = 'Kanji_Bangou',
	[0x0100113d] = 'Zen_Koho',
	[0x0100113e] = 'Mae_Koho',
	[0x01001131] = 'Hangul',
	[0x01001132] = 'Hangul_Start',
	[0x01001133] = 'Hangul_End',
	[0x01001134] = 'Hangul_Hanja',
	[0x01001135] = 'Hangul_Jamo',
	[0x01001136] = 'Hangul_Romaja',
	[0x01001137] = 'Hangul_Codeinput',
	[0x01001138] = 'Hangul_Jeonja',
	[0x01001139] = 'Hangul_Banja',
	[0x0100113a] = 'Hangul_PreHanja',
	[0x0100113b] = 'Hangul_PostHanja',
	[0x0100113c] = 'Hangul_SingleCandidate',
	[0x0100113d] = 'Hangul_MultipleCandidate',
	[0x0100113e] = 'Hangul_PreviousCandidate',
	[0x0100113f] = 'Hangul_Special',
	[0x0100117e] = 'Hangul_switch',
	[0x01001250] = 'Dead_Grave',
	[0x01001251] = 'Dead_Acute',
	[0x01001252] = 'Dead_Circumflex',
	[0x01001253] = 'Dead_Tilde',
	[0x01001254] = 'Dead_Macron',
	[0x01001255] = 'Dead_Breve',
	[0x01001256] = 'Dead_Abovedot',
	[0x01001257] = 'Dead_Diaeresis',
	[0x01001258] = 'Dead_Abovering',
	[0x01001259] = 'Dead_Doubleacute',
	[0x0100125a] = 'Dead_Caron',
	[0x0100125b] = 'Dead_Cedilla',
	[0x0100125c] = 'Dead_Ogonek',
	[0x0100125d] = 'Dead_Iota',
	[0x0100125e] = 'Dead_Voiced_Sound',
	[0x0100125f] = 'Dead_Semivoiced_Sound',
	[0x01001260] = 'Dead_Belowdot',
	[0x01001261] = 'Dead_Hook',
	[0x01001262] = 'Dead_Horn',
	[0x01000061] = 'Back',
	[0x01000062] = 'Forward',
	[0x01000063] = 'Stop',
	[0x01000064] = 'Refresh',
	[0x01000070] = 'VolumeDown',
	[0x01000071] = 'VolumeMute',
	[0x01000072] = 'VolumeUp',
	[0x01000073] = 'BassBoost',
	[0x01000074] = 'BassUp',
	[0x01000075] = 'BassDown',
	[0x01000076] = 'TrebleUp',
	[0x01000077] = 'TrebleDown',
	[0x01000080] = 'MediaPlay',
	[0x01000081] = 'MediaStop',
	[0x01000082] = 'MediaPrevious',
	[0x01000083] = 'MediaNext',
	[0x01000084] = 'MediaRecord',
	[0x01000090] = 'HomePage',
	[0x01000091] = 'Favorites',
	[0x01000092] = 'Search',
	[0x01000093] = 'Standby',
	[0x01000094] = 'OpenUrl',
	[0x010000a0] = 'LaunchMail',
	[0x010000a1] = 'LaunchMedia',
	[0x010000a2] = 'Launch0',
	[0x010000a3] = 'Launch1',
	[0x010000a4] = 'Launch2',
	[0x010000a5] = 'Launch3',
	[0x010000a6] = 'Launch4',
	[0x010000a7] = 'Launch5',
	[0x010000a8] = 'Launch6',
	[0x010000a9] = 'Launch7',
	[0x010000aa] = 'Launch8',
	[0x010000ab] = 'Launch9',
	[0x010000ac] = 'LaunchA',
	[0x010000ad] = 'LaunchB',
	[0x010000ae] = 'LaunchC',
	[0x010000af] = 'LaunchD',
	[0x010000b0] = 'LaunchE',
	[0x010000b1] = 'LaunchF',
	[0x0100ffff] = 'MediaLast',
	[0x01010000] = 'Select',
	[0x01010001] = 'Yes',
	[0x01010002] = 'No',
	[0x01020001] = 'Cancel',
	[0x01020002] = 'Printer',
	[0x01020003] = 'Execute',
	[0x01020004] = 'Sleep',
	[0x01020005] = 'Play',
	[0x01020006] = 'Zoom',
	[0x01020007] = 'Jisho',
	[0x01020008] = 'Oyayubi_Left',
	[0x01020009] = 'Oyayubi_Right',
	[0x01100000] = 'Context1',
	[0x01100001] = 'Context2',
	[0x01100002] = 'Context3',
	[0x01100003] = 'Context4',
	[0x01100004] = 'Call',
	[0x01100005] = 'Hangup',
	[0x01100006] = 'Flip',
	[0x01ffffff] = 'unknown',
}
